#!/usr/bin/env python
#
import pylab as pl
import numpy as np; from numpy import mean, median, zeros, hstack, vstack, asarray, asmatrix, nan, var, cov
import scipy; from scipy.misc import comb
import itertools; from itertools import combinations
import collections; from collections import Counter 

N = 5 
vs_wo_delta = [ 0., -1., +1. ]
delta_values = [0., 0.5, 1.0, 1.5]
s = 3 

for dv in delta_values : 
    vs = vs_wo_delta + [ dv, -dv ] 

    # Compute the distribution of the median of this sample (of s items) of vs
    count_median_value_given_delta = {} 
    for c in combinations(vs,s): 
        m = median(c)
        count_median_value_given_delta[m] = count_median_value_given_delta.get(m,0) + 1 

    for k in count_median_value_given_delta.keys() : 
        count_median_value_given_delta[k] = count_median_value_given_delta[k] / float( comb(N,s,exact=True) )

    # Compute the variance of the sample median: 
    m  = sum( [ _ * count_median_value_given_delta[_] for _ in count_median_value_given_delta ] ) # the keys are the values of the median 
    m2 = sum( [ (_**2) * count_median_value_given_delta[_] for _ in count_median_value_given_delta ] ) # the keys are the values of the median 
    var_median = m2 - m**2 

    print "Delta= ", dv
    print "Mean: variance=", (1+dv**2)/15.
    print "Median: distribution=", count_median_value_given_delta, "variance=", var_median
    
